<?php

/**
 * Shows a single TraceKit report.
 */
function tracekit_report_details($id) {
  $result = db_query("SELECT * FROM {tracekit_report} WHERE tracekit_report_id = :id", array(':id' => $id))->fetchObject();

  if ($report = $result) {
    $account = user_load($report->uid);
    $stack = json_decode($report->stack);
    $stacktrace = '';

    foreach ($stack as $key => $trace) {
      $context_output = '<pre>';

      foreach ($trace->context as $context) {
        $context_output .= "\n" . check_plain($context);
      }

      $context_output .= '</pre>';

      $rows = array(
        array(
          array('data' => t('URL'), 'header' => TRUE),
          check_plain($trace->url),
        ),
        array(
          array('data' => t('Function'), 'header' => TRUE),
          check_plain($trace->func),
        ),
        array(
          array('data' => t('Arguments'), 'header' => TRUE),
          check_plain($trace->args),
        ),
        array(
          array('data' => t('Line'), 'header' => TRUE),
          check_plain($trace->line),
        ),
        array(
          array('data' => t('Column'), 'header' => TRUE),
          check_plain($trace->column),
        ),
        array(
          array('data' => t('Context'), 'header' => TRUE),
          $context_output,
        ),
      );

      $build_sub['stacktrace' . $key] = array(
        '#theme' => 'table',
        '#rows' => $rows,
      );
    }

    $rows = array(
      array(
        array('data' => t('Mode'), 'header' => TRUE),
        check_plain($report->mode),
      ),
      array(
        array('data' => t('Date'), 'header' => TRUE),
        format_date($report->created, 'long'),
      ),
      array(
        array('data' => t('Message'), 'header' => TRUE),
        check_plain($report->message),
      ),
      array(
        array('data' => t('User'), 'header' => TRUE),
        theme('username', array('account' => $account)),
      ),
      array(
        array('data' => t('Location'), 'header' => TRUE),
        l($report->url, $report->url),
      ),
      array(
        array('data' => t('Useragent'), 'header' => TRUE),
        check_plain($report->useragent),
      ),
      array(
        array('data' => t('Stacktrace'), 'header' => TRUE),
        drupal_render($build_sub),
      ),
    );

    $build['tracekit_table'] = array(
      '#theme' => 'table',
      '#rows' => $rows,
    );

    return $build;
  }
  else {
    return '';
  }
}
